var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ThreadScheduler_instances, _ThreadScheduler_tasks, _ThreadScheduler_topTask, _ThreadScheduler_workCycleTracker, _ThreadScheduler_completeTask, _ThreadScheduler_insertTask, _ThreadScheduler_removeTask;
import WorkCycleTracker from './WorkCycleTracker';
import withResolvers from './utils/withResolvers';
import { requestPromiseEscape } from './utils/promiseEscape';
import ReactiveTask from './utils/ReactiveTask';
const strategyPriorities = {
    interactive: 30,
    smooth: 20,
    idle: 10,
};
class ThreadScheduler {
    constructor() {
        _ThreadScheduler_instances.add(this);
        _ThreadScheduler_tasks.set(this, []);
        _ThreadScheduler_topTask.set(this, new ReactiveTask());
        _ThreadScheduler_workCycleTracker.set(this, new WorkCycleTracker());
        __classPrivateFieldGet(this, _ThreadScheduler_topTask, "f").setEffect(async (task, signal) => {
            __classPrivateFieldGet(this, _ThreadScheduler_workCycleTracker, "f").startTracking();
            await __classPrivateFieldGet(this, _ThreadScheduler_instances, "m", _ThreadScheduler_completeTask).call(this, task, signal);
            if (__classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").length === 0) {
                __classPrivateFieldGet(this, _ThreadScheduler_workCycleTracker, "f").requestStopTracking();
            }
        });
    }
    createTask(strategy) {
        const task = { ...withResolvers(), strategy };
        __classPrivateFieldGet(this, _ThreadScheduler_instances, "m", _ThreadScheduler_insertTask).call(this, task);
        return task;
    }
    isTimeToYield(strategy) {
        return !__classPrivateFieldGet(this, _ThreadScheduler_workCycleTracker, "f").canWorkMore(strategy);
    }
}
_ThreadScheduler_tasks = new WeakMap(), _ThreadScheduler_topTask = new WeakMap(), _ThreadScheduler_workCycleTracker = new WeakMap(), _ThreadScheduler_instances = new WeakSet(), _ThreadScheduler_completeTask = async function _ThreadScheduler_completeTask(task, signal) {
    while (!__classPrivateFieldGet(this, _ThreadScheduler_workCycleTracker, "f").canWorkMore(task.strategy)) {
        await __classPrivateFieldGet(this, _ThreadScheduler_workCycleTracker, "f").nextWorkCycle(task.strategy);
        if (signal.aborted) {
            return;
        }
    }
    task.resolve();
    // wait for the user code to continue running the code to see if he will add more work to
    // be done. we prefer this, other than continuing to the next task immediately
    await new Promise((resolve) => requestPromiseEscape(resolve));
    __classPrivateFieldGet(this, _ThreadScheduler_instances, "m", _ThreadScheduler_removeTask).call(this, task);
}, _ThreadScheduler_insertTask = function _ThreadScheduler_insertTask(task) {
    const priority = strategyPriorities[task.strategy];
    for (let i = 0; i < __classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").length; i++) {
        if (priority >= strategyPriorities[__classPrivateFieldGet(this, _ThreadScheduler_tasks, "f")[i].strategy]) {
            __classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").splice(i, 0, task);
            __classPrivateFieldGet(this, _ThreadScheduler_topTask, "f").set(__classPrivateFieldGet(this, _ThreadScheduler_tasks, "f")[0]);
            return;
        }
    }
    __classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").push(task);
    __classPrivateFieldGet(this, _ThreadScheduler_topTask, "f").set(__classPrivateFieldGet(this, _ThreadScheduler_tasks, "f")[0]);
}, _ThreadScheduler_removeTask = function _ThreadScheduler_removeTask(task) {
    const index = __classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").indexOf(task);
    if (index !== -1) {
        __classPrivateFieldGet(this, _ThreadScheduler_tasks, "f").splice(index, 1);
    }
    if (index === 0) {
        __classPrivateFieldGet(this, _ThreadScheduler_topTask, "f").set(__classPrivateFieldGet(this, _ThreadScheduler_tasks, "f")[0]);
    }
};
const threadScheduler = new ThreadScheduler();
export default threadScheduler;
