var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _WorkCycleTracker_instances, _WorkCycleTracker_workCycleStart, _WorkCycleTracker_calculateDeadline;
import ricTracker from './ricTracker';
import frameTracker from './frameTracker';
export default class WorkCycleTracker {
    constructor() {
        _WorkCycleTracker_instances.add(this);
        _WorkCycleTracker_workCycleStart.set(this, -1);
    }
    startTracking() {
        ricTracker.start();
        frameTracker.start();
    }
    requestStopTracking() {
        ricTracker.stop();
        frameTracker.requestStop();
    }
    canWorkMore(strategy) {
        var _a, _b;
        const isInputPending = ((_b = (_a = navigator.scheduling) === null || _a === void 0 ? void 0 : _a.isInputPending) === null || _b === void 0 ? void 0 : _b.call(_a)) === true;
        return !isInputPending && __classPrivateFieldGet(this, _WorkCycleTracker_instances, "m", _WorkCycleTracker_calculateDeadline).call(this, strategy) - Date.now() > 0;
    }
    async nextWorkCycle(strategy) {
        if (strategy === 'interactive') {
            await frameTracker.waitAfterFrame();
        }
        else if (strategy === 'smooth') {
            await frameTracker.waitAfterFrame();
        }
        else if (strategy === 'idle') {
            if (ricTracker.available) {
                await ricTracker.waitIdleCallback();
            }
            else {
                await frameTracker.waitAfterFrame();
            }
        }
        __classPrivateFieldSet(this, _WorkCycleTracker_workCycleStart, Date.now(), "f");
    }
}
_WorkCycleTracker_workCycleStart = new WeakMap(), _WorkCycleTracker_instances = new WeakSet(), _WorkCycleTracker_calculateDeadline = function _WorkCycleTracker_calculateDeadline(strategy) {
    if (strategy === 'interactive') {
        return __classPrivateFieldGet(this, _WorkCycleTracker_workCycleStart, "f") + 83;
    }
    else if (strategy === 'smooth') {
        return __classPrivateFieldGet(this, _WorkCycleTracker_workCycleStart, "f") + 13;
    }
    else if (strategy === 'idle') {
        const idleDeadline = ricTracker.deadline === undefined
            ? Number.MAX_SAFE_INTEGER
            : Date.now() + ricTracker.deadline.timeRemaining();
        return Math.min(__classPrivateFieldGet(this, _WorkCycleTracker_workCycleStart, "f") + 5, idleDeadline);
    }
    return -1;
};
