var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _FrameTracker_instances, _FrameTracker_timeoutId, _FrameTracker_requestAnimationId, _FrameTracker_deferred, _FrameTracker_loop;
import withResolvers from './utils/withResolvers';
import { queueTask } from '../index';
class FrameTracker {
    constructor() {
        _FrameTracker_instances.add(this);
        _FrameTracker_timeoutId.set(this, void 0);
        _FrameTracker_requestAnimationId.set(this, void 0);
        _FrameTracker_deferred.set(this, void 0);
        __classPrivateFieldSet(this, _FrameTracker_deferred, withResolvers(), "f");
    }
    async waitAnimationFrame() {
        return __classPrivateFieldGet(this, _FrameTracker_deferred, "f").promise;
    }
    async waitAfterFrame() {
        await __classPrivateFieldGet(this, _FrameTracker_deferred, "f").promise;
        await new Promise((resolve) => queueTask(resolve));
    }
    start() {
        clearTimeout(__classPrivateFieldGet(this, _FrameTracker_timeoutId, "f"));
        __classPrivateFieldSet(this, _FrameTracker_timeoutId, undefined, "f");
        __classPrivateFieldGet(this, _FrameTracker_instances, "m", _FrameTracker_loop).call(this);
    }
    requestStop() {
        if (__classPrivateFieldGet(this, _FrameTracker_timeoutId, "f") === undefined) {
            __classPrivateFieldSet(this, _FrameTracker_timeoutId, setTimeout(() => {
                __classPrivateFieldSet(this, _FrameTracker_timeoutId, undefined, "f");
                cancelAnimationFrame(__classPrivateFieldGet(this, _FrameTracker_requestAnimationId, "f"));
                __classPrivateFieldSet(this, _FrameTracker_requestAnimationId, undefined, "f");
            }, 200), "f");
        }
    }
}
_FrameTracker_timeoutId = new WeakMap(), _FrameTracker_requestAnimationId = new WeakMap(), _FrameTracker_deferred = new WeakMap(), _FrameTracker_instances = new WeakSet(), _FrameTracker_loop = function _FrameTracker_loop() {
    if (__classPrivateFieldGet(this, _FrameTracker_requestAnimationId, "f") === undefined) {
        __classPrivateFieldSet(this, _FrameTracker_requestAnimationId, requestAnimationFrame(() => {
            __classPrivateFieldSet(this, _FrameTracker_requestAnimationId, undefined, "f");
            __classPrivateFieldGet(this, _FrameTracker_deferred, "f").resolve();
            __classPrivateFieldSet(this, _FrameTracker_deferred, withResolvers(), "f");
            __classPrivateFieldGet(this, _FrameTracker_instances, "m", _FrameTracker_loop).call(this);
        }), "f");
    }
};
const frameTracker = new FrameTracker();
export default frameTracker;
