import SchedulingStrategy from './SchedulingStrategy';
/**
 * If there is more time left — immediately returns so the task can continue. If no more time left,
 * it waits for the browser to become idle again in order to resume work. Calling
 * `yieldOrContinue()` multiple times will create a LIFO(last in, first out) queue – the last call
 * to `yieldOrContinue()` will get resolved first.
 *
 * @param priority {SchedulingStrategy} The priority of the task being run.
 * `smooth` priority will always be resolved first. `background` priority will always be
 * resolved second.
 * @returns {Promise<void>} A promise either immediately resolved or when the browser is ready to
 * do work again.
 */
export default function yieldOrContinue(priority?: SchedulingStrategy): Promise<void>;
